#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>       //Download: https://www.electronoobs.com/eng_arduino_Adafruit_GFX.php
#include <Adafruit_SSD1306.h>   //Downlaod: https://www.electronoobs.com/eng_arduino_Adafruit_SSD1306.php
Adafruit_SSD1306 display(4);    //Create screen variable

#include <Wire.h>
#include <Adafruit_ADS1015.h>   //Download: https://electronoobs.com/eng_arduino_Adafruit_ADS1015.php
 
Adafruit_ADS1115 ads(0x48);
Adafruit_ADS1115 ads2(0x49);
const float multiplier = 0.1875F;   //From datasheet

//Define all the Input/output pins of the board
int D2 = 2;     //MUX 1
int D3 = 3;     //MUX 2
int D4 = 4;     //Resistance 20K
int D5 = 5;     //Resistance 470K
int D6 = 6;     //Inductance pulse
int D7 = 7;     //Voltage divider R
int D8 = 8;     //Resistance 2K
int D9 = 9;     //Inductance out
int D10 = 10;   //Push button
int D11 = 11;   //Capacitance 10K
int D12 = 12;   //Voltage divider L
int D13 = 13;   //Capacitance 220K
int a0 = A0;    //Capacitance Read
int a1 = A1;    //Resistance diode 
int a2 = A2;    //Capacitance RC
int a3 = A3;    //MUX 0
int a6 = A6;    
int a7 = A7;    


//Resistance mode variables
float R2K = 1997;
float R20K = 19.89;      //In K ohms
float R470K = 441;     //in K ohms
int Res_Offset = 0;
bool conductivity = true;
float DividerVoltage = 0.0;

void setup() {
  Serial.begin(9600);
  //Define all pins as inputs but not the pins that we will use
  pinMode(a0, INPUT);
  //pinMode(a1, INPUT);
  pinMode(a2, INPUT);
  pinMode(a3, INPUT);
  pinMode(a6, INPUT);
  pinMode(a7, INPUT);  
  pinMode(D2, INPUT);
  pinMode(D3, INPUT);
  pinMode(D4, INPUT);
  pinMode(D5, INPUT);
  pinMode(D6, INPUT);
  pinMode(D7, INPUT);
  pinMode(D8, INPUT);
  pinMode(D9, INPUT);
  pinMode(D10, INPUT);
  pinMode(D11, INPUT);
  pinMode(D12, INPUT);
  pinMode(D13, INPUT);

  ads.begin();  //Start i2c communication with the first ADS1115
  ads2.begin();  //Start i2c communication with the second ADS1115
  
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  //Start i2c communication
  //display.setRotation(2);                     //Rotate screen 180 degree
  display.clearDisplay();                     //Clear the display data
  display.display();                          //Send data to the display
  delay(10);

}

void loop() {
  //MUX setup
  pinMode(a3, OUTPUT);  //S0 of mux
  pinMode(D2, OUTPUT);  //S1 of mux
  pinMode(D3, OUTPUT);  //S2 of mux
  //We set "001" so we activate MUX2 for Resistance mode (RC)
  digitalWrite(a3, HIGH);   //S0 to 1
  digitalWrite(D2, LOW);    //S1 to 0
  digitalWrite(D3, LOW);    //S2 to 0

  pinMode(A1,OUTPUT);
  digitalWrite(A1,HIGH);    
  
  pinMode(D4,INPUT);
  pinMode(D5,INPUT);
  pinMode(D8,OUTPUT);
  digitalWrite(D8,LOW);   
  delay(10); 

  //We read the VCC voltage
  float adc4; 
  adc4 = ads2.readADC_SingleEnded(0);
  float VccVoltage = (adc4 * 0.1875)/1000;
  VccVoltage = VccVoltage * 4.09;
  Serial.println(VccVoltage);
    
  float adc2;     
  float res;
  adc2 = ads.readADC_SingleEnded(2);
  DividerVoltage = (adc2 * 0.1875)/1000;
  res = ((R2K*VccVoltage)/DividerVoltage) - R2K - Res_Offset;

  if(res < 2000)
  {          
    display.clearDisplay();  
    display.setTextSize(2);
    display.setTextColor(WHITE);    
    display.setCursor(4,0);
    display.print("RESISTANCE");
    
    display.setTextSize(2);
    display.setTextColor(WHITE);    
    display.setCursor(0,18);
    display.print(res,0);
    display.println(" Ohms");
    display.display();
  }
  else if(res < 20000)
  {     
    pinMode(D8,INPUT);    
    pinMode(D5,INPUT);
    pinMode(D4,OUTPUT);
    digitalWrite(D4,LOW);       
    delay(10);           
   
    adc2 = ads.readADC_SingleEnded(2);
    DividerVoltage = (adc2 * 0.1875)/1000;      
    res = ((R20K*VccVoltage)/DividerVoltage) - R20K;       
    
    display.clearDisplay();  
    display.setTextSize(2);
    display.setTextColor(WHITE);    
    display.setCursor(4,0);
    display.print("RESISTANCE");
    
    display.setTextSize(2);
    display.setTextColor(WHITE);    
    display.setCursor(0,18);
    display.print(res,2);
    display.println(" K");
    display.display();
  }

  else if(res > 20000) 
  {
    pinMode(D8,INPUT);
    pinMode(D4,INPUT); 
    pinMode(D5,OUTPUT);
    digitalWrite(D5,LOW);       
    delay(10);  
           
    adc2 = ads.readADC_SingleEnded(2);
    DividerVoltage = (adc2 * 0.1875)/1000;      
    res = ((R470K*DividerVoltage)/DividerVoltage) - R470K;          //3.422V(AMS1117 3.3V) -0.616V (diode)
    if(res < 2000)
    {      
      display.clearDisplay();  
      display.setTextSize(2);
      display.setTextColor(WHITE);    
      display.setCursor(4,0);
      display.print("RESISTANCE");
      
      display.setTextSize(2);
      display.setTextColor(WHITE);    
      display.setCursor(0,18);
      display.print(res,1);
      display.println(" K");
      display.display();        
    }
    else
    {
      display.clearDisplay();  
      display.setTextSize(2);
      display.setTextColor(WHITE);    
      display.setCursor(4,0);
      display.print("RESISTANCE");
      
      display.setTextSize(2);
      display.setTextColor(WHITE);    
      display.setCursor(0,18);
      display.println("NONE");     
      display.display();
    }    
  } 
  delay(50);


 
}
